package org.jboss.as.quickstarts.servlet;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.annotation.WebServlet;

@WebServlet("/InputServlet2")
public class InputServlet2 extends HttpServlet {

    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        doPost(request, response);
    }

    protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        request.setCharacterEncoding("UTF-8");
        String s = request.getParameter("hello");
        if (s != null) { 
            System.out.println("hello : " + s);
            printDump(s.getBytes("Shift_JIS"));
        }

        response.setCharacterEncoding("UTF-8");
        response.setContentType("text/html; charset=UTF-8");

        PrintWriter out = response.getWriter();
        out.println("<html>");
        out.println("<body>");
        out.println("<p>hello : " + s + "</p>");
        out.println("</body>");
        out.println("</html>");
    }


    /** 
     * Debug Byte Array
     * @param b byte array 
     */
    protected void printDump(byte[] b) {
        System.out.println("Dump length="+b.length);
        System.out.print("addr: 00-01-02-03-04-05-06-07-08-09-0a-0b-0c-0d-0e-0f");
        for(int i=0; i<b.length; i++) {
            if (i%16==0) {
                System.out.printf("\n%04x: ", i);
            }
            System.out.printf("%02x ", b[i]);
        }
        System.out.println("");
    }

}
